//Node.h
#ifndef __NODE_H
#define __NODE_H

#include <list>
#include <string>
#include <vector>

class Node;
typedef std::vector<Node*> NodeVector;

class Node
{
public:
	Node();
	virtual	~Node();

	void	AttachChild( Node* pChild );
	void	DetachChild( Node* pChild );
	Node*	GetRoot();
	Node*	GetParent();

	void			SetData( std::string* pData );
	std::string*	GetData();
	static void		PrintAll( Node* pNode );

	std::string*	GetClassName();
	void			SetClassName( const char* szClassName );
	void			AddAttribute( const char* pName, const char* pValue );
	void			FindNode( const char* pName, NodeVector& nodeArr );

protected:
	void			FindNodeAll( const std::vector<std::string>& tok, int iDepth, NodeVector& nodeArr );

protected:
	struct Attribute
	{
		std::string name;
		std::string value;

		Attribute( const char* _name, const char* _value )
		{
			name = _name;
			value = _value;
		}
	};
	typedef std::list <Node*>			ChildList;
	typedef std::vector <Attribute*>	AttributeList;

	std::string*	m_pData;
	std::string		m_className;
	Node*			m_pParent;
	ChildList		m_child;  
	AttributeList	m_attribute;
};

#endif