//TreeNode.cpp
#include "TreeNode.h"
#include <assert.h>
#include <iostream>
#include <stdio.h>

template <typename T>
TreeNode<T>::TreeNode()
: m_pParent( NULL ) 
, m_child( NULL )
, m_pData( NULL )
{	
}
//-----------------------------------------------------------------------------
template <typename T>
TreeNode<T>::~TreeNode()
{	
	if( m_pData )
	{
		delete m_pData;
		m_pData = NULL;
	}

	ChildList::iterator iter = m_child.begin();
	ChildList::iterator endIter = m_child.end();
	for( ; iter != endIter; ++iter )
	{
		delete (*iter);
	}

	m_child.clear();
}
//-----------------------------------------------------------------------------
template <typename T>
void TreeNode<T>::AttachChild( TreeNode* pChild )
{
	pChild->m_pParent = this;
	m_child.push_back( pChild );
}
//-----------------------------------------------------------------------------
template <typename T>
void TreeNode<T>::DetachChild( TreeNode* pChild )
{
	ChildList::iterator iter = m_child.begin();
	ChildList::iterator endIter = m_child.end();
	for( ; iter != endIter; ++iter )
	{
		if( pChild == *iter )
		{
			delete (*iter);
			m_child.erase( iter );
			break;
		}
	}
}
//-----------------------------------------------------------------------------
template <typename T>
TreeNode<T>* TreeNode<T>::GetRoot()
{
	return m_pParent ? m_pParent->GetRoot() : this;
}
//---------------------------------------------------------------------------
template <typename T>
void TreeNode<T>::SetData( T* pData )
{
	m_pData = pData;
}
//-----------------------------------------------------------------------------
template <typename T>
T* TreeNode<T>::GetData()
{
	return m_pData;
}
//-----------------------------------------------------------------------------
template <typename T>
void TreeNode<T>::PrintAll( TreeNode<T>* pNode )
{
	std::cout << "Node Name : " << pNode->GetData()->c_str() << std::endl;
	if( pNode->m_child.empty() == true )
		return;
	
	ChildList::iterator iter = pNode->m_child.begin();
	ChildList::iterator endIter = pNode->m_child.end();
	for( ; iter != endIter; ++iter )
	{
		PrintAll( *iter );
	}
}
